Module modSQLDMORoutines

    Sub LoadSQLServers(ByRef lstSQLServers As ListBox)

        Dim intCurrSQL As Integer
        Dim oNames As SQLDMO.NameList
        Dim oSQLApp As New SQLDMO.Application()

        '-- Load available SQL Servers into a NameList 
        '   (those that are able to be seen by the network)
        oNames = oSQLApp.ListAvailableSQLServers

        '-- Load the local instance as first in the list, if not on the network.
        If oNames.Count = 0 Then
            lstSQLServers.Items.Add("(local)")
        End If

        '-- Load the namelist into the listbox
        For intCurrSQL = 1 To oNames.Count
            lstSQLServers.Items.Add(oNames.Item(intCurrSQL))
        Next intCurrSQL

        '-- Choose the first instance
        lstSQLServers.SelectedIndex = 0

    End Sub

    Function GetSQLDatabases(ByVal strSQLServer As String, ByRef lstTemp As ListBox)

        Dim intDBs As Integer
        Dim db As Object
        Dim strDBs As String

        '-- Establish a connection to the server. If not then exit the function.
        Dim osvr As SQLDMO.SQLServer
        osvr = New SQLDMO.SQLServer()

        osvr.LoginSecure = True

        Try

            osvr.Connect(strSQLServer)

        Catch excp As Exception

            MessageBox.Show("There is a problem retrieving databases for this server. " & _
                    "Please check the name and try again. ", vbInformation, "Error with Server")
            Exit Function

        End Try

        '-- Clear the current list
        lstTemp.Items.Clear()

        '-- Load up the database names for the selected server into the listbox.    
        For Each db In osvr.Databases
            lstTemp.Items.Add(db.Name)
        Next

    End Function

    Function BuildCnnStr(ByVal strServer As String, ByVal strDatabase As String) As String

        Dim strTemp As String
        strTemp = "Provider=SQLOleDB; Data Source=" & strServer & ";"
        strTemp &= "Initial Catalog=" & strDatabase & ";"
        strTemp &= "Integrated Security=SSPI"

        Return strTemp

    End Function

    Public Sub GetBackupDevices(ByVal strSQLServer As String, _
                                        ByRef lstBackupDevices As ListBox)

        Dim oDevice As SQLDMO.BackupDevice

        '-- Logon to the SQL Server.
        Dim osvr As SQLDMO.SQLServer = New SQLDMO.SQLServer()

        osvr.LoginSecure = True
        osvr.Connect(strSQLServer)

        lstBackupDevices.Items.Clear()

        '-- Iterate through the backup devices.
        For Each oDevice In osvr.BackupDevices
            lstBackupDevices.Items.Add(oDevice.Name)
        Next

    End Sub

End Module
